#
# kab Plugin for BigBrotherBot(B3) (www.bigbrotherbot.net)
# Copyright (C) 2011 Courgette
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# Modified
#
__version__ = '1.10'
__author__  = 'wkuzma'
import re, time, threading, sys, traceback, thread, random
from ConfigParser import NoOptionError
import b3
import b3.events
import b3.plugin
import time
from b3.clients import Client, Group

class KabPlugin(b3.plugin.Plugin):
    def onLoadConfig(self):
        self.cmd_kickplayer_minlevel = self.config.get('command_level', 'kickplayer')
        self.cmd_banplayer_minlevel = self.config.get('command_level', 'banplayer')
        self.cmd_website_text = self.config.get('website', 'website_text')
        self.cmd_changemap_minlevel = self.config.get('command_level', 'changemap')
        self.cmd_tempbanplayer_minlevel = self.config.get('command_level', 'tempbanplayer')
        self.cmd_getss_minlevel = self.config.get('command_level', 'getss')
        self.cmd_gamepassword_minlevel = self.config.get('command_level', 'gamepassword')
        self.cmd_screenwrite_minlevel = self.config.get('command_level', 'screenwrite')
        self.cmd_undercover_minlevel = self.config.get('command_level', 'undercover')
        self.cmd_consay_minlevel = self.config.get('command_level', 'consay')
        self.cmd_maprotate_minlevel = self.config.get('command_level', 'maprotate')
        self.cmd_kab_minlevel = self.config.get('command_level', 'kab')
        self.cmd_heli_minlevel = self.config.get('command_level', 'heli')
        self.cmd_unbanplayer_minlevel = self.config.get('command_level', 'unbanplayer')
        self.cmd_kabsay_minlevel = self.config.get('command_level', 'kabsay')

    def onStartup(self):
        # get the admin plugin so we can register commands
        self._adminPlugin = self.console.getPlugin('admin')

        if not self._adminPlugin:
            # something is wrong, can't start without admin plugin
            self.error('Could not find admin plugin')

            self.registerEvent(b3.events.EVT_CLIENT_AUTH)
            self.verbose('registered CLIENT_AUTH event')
            self.verbose('registered CLIENT_AUTH event')
            return
        # Register commands

        self._adminPlugin.registerCommand(self, 'kickplayer',self.cmd_kickplayer_minlevel, self.cmd_kp, 'kp')
        self._adminPlugin.registerCommand(self, 'banplayer', self.cmd_banplayer_minlevel, self.bp, 'bp')
        self._adminPlugin.registerCommand(self, 'tempbanplayer',self.cmd_tempbanplayer_minlevel, self.tbp, 'tbp')
        self._adminPlugin.registerCommand(self, 'getss', self.cmd_getss_minlevel, self.getss, 'getss')
        self._adminPlugin.registerCommand(self, 'gamepassword', self.cmd_gamepassword_minlevel, self.pw, 'pw')
        self._adminPlugin.registerCommand(self, 'undercover', self.cmd_undercover_minlevel, self.uc, 'uc')
        self._adminPlugin.registerCommand(self, 'screenwrite', self.cmd_screenwrite_minlevel, self.sw, 'sw')
        self._adminPlugin.registerCommand(self, 'maprotate', self.cmd_maprotate_minlevel, self.rt, 'rt')
        self._adminPlugin.registerCommand(self, 'consay', self.cmd_consay_minlevel, self.con, 'con')
        self._adminPlugin.registerCommand(self, 'changemap', self.cmd_changemap_minlevel, self.mp, 'mp')
        self._adminPlugin.registerCommand(self, 'kab', self.cmd_kab_minlevel, self.kab, 'kab')
        self._adminPlugin.registerCommand(self, 'heli', self.cmd_heli_minlevel, self.heli, 'hc')
        self._adminPlugin.registerCommand(self, 'unbanplayer', self.cmd_unbanplayer_minlevel, self.ubp, 'ubp')
        self._adminPlugin.registerCommand(self, 'kabsay', self.cmd_kabsay_minlevel, self.kbc, 'kbc')
        self._adminPlugin.registerCommand(self, 'scorelimit', 0, self.scorelimit, 'sl')



    def mp(self, data, client, cmd=None):
        """
        Change maps example: !mp crash dm will only select dm
        """
        if not data:
            client.message(' %s ^7Your missing data, example !mp crash dm' % client.name)
            return
        else:

                input = data.split(' ',1)
        map = input[0]
        input[0] = 'mp_%s'% input[0]
      #---------------------------------------
        if input[1] == 'tdm' : input[1] = 'war'
        if input[1] == 'hq' : input[1] = 'koth'
      #----------------------------------------
        if input[1] == 'dom' : gametype = 'Domination'
        if input[1] == 'sab' : gametype = 'Sabotage'
        if input[1] == 'war' : gametype = 'Team Deathmatch'
        if input[1] == 'koth' : gametype = 'Headquaters'
        if input[1] == 'sd' : gametype = 'Search and destroy'
        if input[1] == 'dm' : gametype = 'Deathmatch'
        #gametype = 'Deathmatch'
        if input[1] != '' :
  	    self.console.say('^2Map will change to^3 %s ^2gametype^3 %s'% (map,gametype))
        self.console.say('^2Map will change to^3 %s,'% map)
    	self.console.say('^2and the gametype to^3 %s'% gametype)
    	#if input[1] != 'dm' :self.console.say('^2Sorry this is a Free For All server!')
    	time.sleep(2)
    	self.console.say('^2Loading ^3%s ^2in^1 3'% map)
    	time.sleep(1)
    	self.console.say('^2Loading ^3%s ^2in^3 2'% map)
    	time.sleep(1)
        self.console.write('g_gametype "%s"'% input[1])
    #	self.console.write('g_gametype "%s"'% 'dm')
    	time.sleep(1)
    	self.console.say('^2Loading ^3%s ^2in^4 1'% map)
    	time.sleep(1)
    	self.console.write('map %s'% input[0])
        time.sleep(1)
    	return True
    	return True


    def con(self, data, client, cmd=None):
        """
       say something to the console
        """

        if not data:
             client.message('%s ^7You did not put anything to write to console' % client.name)
        else:

             self.console.write('consay ^3%s' % data)


    def scorelimit(self, data, client, cmd=None):

        """
     see score limit
        """
        client.message('%s ^7Use $score to to see the scorelimit.' % client.exactName)
       # self.console.write("scr_dm_scorelimit")


    def kbc(self, data, client, cmd=None):
        """
       see !rc commands
        """

        if not data:
            client.message('%s ^7Here is a list of !rc commands - !rc jump on - !rc jump off.' % client.exactName)
            time.sleep(1)
            client.message('!rc grav on = gravity 10 - !rc grav off = gravity 800 ')
            time.sleep(1)
            client.message('!rc maps will show maps that you can change to use !rc mapname to change maps')
            time.sleep(1)
            client.message('!rc mess say messages in mess.gsx')
            time.sleep(1)
            client.message('!rc getss on or off (allows screenshots to be taken every 10 minutes')
            time.sleep(1)
            client.message('!rc score 100 200 or 300 or 400 0r 500 (10 is for testing) Command will only work in dm')
            time.sleep(1)
            client.message('!rc heli loopon heli enters then leaves !rc heli loopoff heli stays')
            time.sleep(1)
            client.message('!rc heli hitoff - heli shoots but no hits !rc heli hiton - shoots to kill')
            time.sleep(1)
            client.message('!rc snipe on will set paintball sniper mode next map')
            time.sleep(1)
            client.message('!rc snipe off return server to normal paintball')
            time.sleep(1)
            client.message('!rc steam off do not use steam names !rc steam on use steam names')
            time.sleep(1)
            client.message('!rc restart restarts current map !rc same on /off all players have same weapon')
            return False
        else:

             client.message('You do not need to put anything after kab')


    def rt(self, data, client, cmd=None):
        """
        Rotate to next map in cycle
        """
        self.console.write('map_rotate')

    def heli(self, data, client, cmd=None):
        """
        Changes the helicopter fly and shoot
        """
        if data == 'loopon':
                self.console.write('scr_heli_loopmax 0')
                client.message('heli enters then leaves')
        if not data:
                client.message('heli loopon helicopter enters then leaves')
                client.message('heli loopoff helicopter enters then flys arround')
                client.message('heli hiton helicopter shoots to kill')
                client.message('heli hitoff helicopter shoots but will not kill')
        elif data == 'help':
                client.message('heli loopon or heli loopoff or heli hiton or heli hitoff !rc help heli for more')
        elif data == 'loopoff':
                self.console.write('scr_heli_loopmax 1')
                client.message('Heli will stay and shoot')
        elif data == 'hiton':
                self.console.write('scr_heli_turretclipsize 40')
                client.message('heli shoots to kill')
        elif data == 'hitoff':
                self.console.write('scr_heli_turretclipsize 0')
                client.message('heli shoot but will not kill')




    	return True

    def sw(self,data, client, cmd):
        """
        Write a message to the main screen !sw for help
        """
        if not data:
            client.message(' %s ^7This will write your message on the main screen !sw message' % client.name)
            time.sleep(1)
            client.message('^7you can also say sw fast tp have it say bind your weapon to shoot faster')
        if data == 'fast':
            self.console.write('screensay Bind your weapon to wheel up or down to shoot faster')
        else:
             self.console.write('screensay %s' % data)


    def uc(self,data, client, cmd):
        """
        Cod4x undercover must use $undercover while in spectate
        """
        if not data:
            client.message('%s ^7This will make you invisible but you must be in spec to use it' % client.name)
            time.sleep(2)
            client.message('and you use the built in admin $undercover')
        else:
             client.message('%s You must use the built admin command $undercover when you are in spec! ' % client.name)

    def pw(self, data, client, cmd):
        """
        Set the game password
        """
        if not data:

            client.message('%s ^7This will set a game password !pw whatever' % client.name)
            time.sleep(1)
            client.message('^7To remove the password type !pw remove')

        else:

             self.console.write('g_password %s' % data)

        if data<>"remove": client.message('%s You added a game password of %s  ' % (client.name, data))
        if data == "remove":
             self.console.write('g_password "')
             client.message('You removed the game password')



    def kab(self, data, client, cmd):
        """
        Show KAB coomands
        """
        if not data:
            client.message('%s These are KAB commands to use with ! in front' % client.name)
            client.message('!kickplayer or !kp to kick a player by name can add reason')
            time.sleep(3)
            client.message('!bp or !banplayer To ban a player by name must add reason')
            time.sleep(3)
            client.message('!tbp or !tempbanplayer to tempban a player by name must add time and reason')
            time.sleep(3)
            client.message('!ubp or !unbanplayer to unban a player you must use $dumpbanlist to get player id names will not work')
            time.sleep(3)
            client.message('!getss take a screenshot of a player or use getss all')
            time.sleep(3)
            client.message('!pw or !gamepassword set a game password - to remove password use pw remove')
            time.sleep(3)
            client.message('!uc or !undercover will make you invisable but you must use the admin command $undercover while in spec')
            time.sleep(3)
            client.message('!sw or !screenwrite will write on the screen what you post after !sw type !sw for help')
            time.sleep(3)
            client.message('!rt or !rotate to change to next map in cycle')
            time.sleep(3)
            client.message('!mp or !changemap (same as before using !map) !mp crash dm or any map and gametype')
            time.sleep(3)
            client.message('!con or !consay to write a message shows where player joining does')
            time.sleep(3)
            client.message('!heli loopon helicopter enters then leaves')
            time.sleep(3)
            client.message('!heli loopoff helicopter enters then flys arround')
            time.sleep(3)
            client.message('!heli hiton helicopter shoots to kill')
            time.sleep(3)
            client.message('!heli hitoff helicopter shoots but will not kill')
            time.sleep(3)
            client.message('%s ^5!kab help will give some help if a command does not work for you' % client.name)
        elif data == 'help':
            client.message('%s If you type a command without data !ubp it will give help on using the command  ' % client.name)
            client.message('NOTE: If you type a command without data !ubp and do not get help you do not have access to that command  ')

    def getss(self, data, client, cmd):
        """
        Get screen shot of all or player
        """
        if not data:
            client.message('^7getss name or all ')
        else:
             self.console.write('getss %s' % data)
             client.message('%s You took a Screenshot of %s  ' % (client.name, data))
    def ubp(self, data, client, cmd):
        """
        Unban a player must use $dumpmbanlist to get player id
        """
        if not data:
            client.message('^7Missing player id to unban - use $dumpbanlist to get id')
        elif data == 'str':
             self.console.write('unban 2310346615121888849')
             client.message('%s You Unbanned Stranger using %s  ' % (client.name, data))
        elif data == 'rain':
             self.console.write('unban 2310346616304979549')
             client.message('%s You Unbanned Rainstorm using %s  ' % (client.name, data))
        elif data <> 'str':
             self.console.write('unban %s' % data)
             client.message('%s You unbanned %s  ' % (client.name, data))
    def tbp(self, data, client, cmd):
        """
        Tempban a player use !tbp name time m h d
        """
        if not data:
            client.message('^7Missing player to tempban can use 3 letters of name also a time like 15m and a reason is needed')
        else:
             self.console.write('tempban %s' % data)
             client.message('%s You tempbanned %s  ' % (client.name, data))


    def bp(self, data, client, cmd):
        """
        Ban a player  will also use the web site in the config file and add it to the ban file
        """
        if not data:
            client.message('^7Missing player to ban can use 3 letters of name and a reason if needed')
        else:
            # self.console.write('banuser %s you can appeal your ban at www.kab.iob.cod4.com' % data)

             #client.message(self.cmd_website_text)
             self.console.write('banuser %s you can appeal your ban at %s '% (data , (self.cmd_website_text)))
             client.message('%s You banned %s  ' % (client.name, data))
    def cmd_kp(self, data, client, cmd):
        """
        Kick a player by name or part name
        """

        if not data:
            client.message('^7Missing player to kick can use 3 letters of name! ')
        elif data[0:3] == 'str':
             client.message('stranger is safe, but your not! BYE')
             time.sleep(3)

             client.kick('%s that will teach you to try to kick Stranger' % client.name)
        elif data[0:3] == 'Str':
             client.message('stranger is safe, but your not! Watch for it')
             time.sleep(3)
             client.kick('%s that will teach you to try to kick Stranger' % client.name)
        elif data[0:3] == 'STR':
             client.message('stranger is safe, but your not! So long')
             time.sleep(3)
             client.kick('%s that will teach you to try to kick Stranger' % client.name)

        elif data[0:3] == 'fly':
             client.message('Flywheel is safe, but your not! Goodbye')
             time.sleep(3)
             client.kick('%s that will teach you to try to kick Flywheel' % client.name)
        elif data[0:3] == 'Fly':
             client.message('Flywheel is safe, but your not! 1 2 3 Kicked')
             time.sleep(3)
             client.kick('%s that will teach you to try to kick Flywheel' % client.name)
        elif data[0:3] == 'FLY':
             client.message('Flywheel is safe, but your not! Come back after your kicked')
             time.sleep(3)
             client.kick('%s that will teach you to try to kick Flywheel' % client.name)


        else:
            self.console.write('kick %s' % data)

            client.message('%s You kicked %s  ' % (client.name, data))

